import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Frame;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.xml.namespace.QName;

import quadbase.common.util.dtd.elements.DTDDataType;
import quadbase.common.util.internal.XMLFieldInfo;
import quadbase.common.paramquery.SOAPParam;
import quadbase.common.paramquery.SOAPQueryFileInfo;
import quadbase.reportdesigner.ReportAPI.QbReport;
import quadbase.reportdesigner.ReportViewer.Viewer;
import quadbase.reportdesigner.util.ColInfo;

public class SOAP extends Applet{
    static final long serialVersionUID = 1;
    
    public static void main(java.lang.String[] args) {
        try {
            SOAP doReport = new SOAP();
            Frame frame = new Frame();
            frame.setLayout(new BorderLayout());
            frame.add("Center", doReport.doSOAPReport(frame));
            frame.setSize(1080, 800);
            frame.addWindowListener(new WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                    System.exit(0);
                }
            });
            frame.setVisible(true);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    public void init() {
        setLayout(new BorderLayout());
        add("Center", doSOAPReport(this));
    }
    
    Component doSOAPReport(Object parent)  {
        QbReport.setEspressManagerUsed(false);
        
        String wsdlURI = "http://wsf.cdyne.com/WeatherWS/Weather.asmx?WSDL";
        String namespaceURI = "http://ws.cdyne.com/WeatherWS/"; String localPart = "Weather";
        QName serviceName = new QName(namespaceURI, localPart);
        String portName = "WeatherSoap"; String operationName = "GetCityForecastByZIP";
                
        //	 Get the first 5 columns from the data source
        ColInfo[] mapping = new ColInfo[12];
        for (int i = 0; i < mapping.length; i++)
            mapping[i] = new ColInfo(i);
        
        //	 Set up the XML Data Source
        XMLFieldInfo[] fields = new XMLFieldInfo[12];
        fields[0] = new XMLFieldInfo(new String[] {"GetCityForecastByZIPResponse" , "GetCityForecastByZIPResult", "Success"});
        fields[0].setElementDataType(DTDDataType.STRING);
        fields[1] = new XMLFieldInfo(new String[] {"GetCityForecastByZIPResponse" , "GetCityForecastByZIPResult", "ResponseText"});
        fields[1].setElementDataType(DTDDataType.STRING);
        fields[2] = new XMLFieldInfo(new String[] {"GetCityForecastByZIPResponse" , "GetCityForecastByZIPResult", "State"});
        fields[2].setElementDataType(DTDDataType.STRING);
        fields[3] = new XMLFieldInfo(new String[] {"GetCityForecastByZIPResponse" , "GetCityForecastByZIPResult", "City"});
        fields[3].setElementDataType(DTDDataType.STRING);
        fields[4] = new XMLFieldInfo(new String[] {"GetCityForecastByZIPResponse" , "GetCityForecastByZIPResult", "WeatherStationCity"});
        fields[4].setElementDataType(DTDDataType.STRING);
        fields[5] = new XMLFieldInfo(new String[] {"GetCityForecastByZIPResponse" , "GetCityForecastByZIPResult", "ForecastResult", "Forecast+", "Date"});
        fields[5].setElementDataType(DTDDataType.STRING);
        fields[6] = new XMLFieldInfo(new String[] {"GetCityForecastByZIPResponse" , "GetCityForecastByZIPResult", "ForecastResult", "Forecast+", "WeatherID"});
        fields[6].setElementDataType(DTDDataType.INT);
        fields[7] = new XMLFieldInfo(new String[] {"GetCityForecastByZIPResponse" , "GetCityForecastByZIPResult", "ForecastResult", "Forecast+", "Description"});
        fields[7].setElementDataType(DTDDataType.STRING);
        fields[8] = new XMLFieldInfo(new String[] {"GetCityForecastByZIPResponse" , "GetCityForecastByZIPResult", "ForecastResult", "Forecast+", "Temperatures", "MorningLow"});
        fields[8].setElementDataType(DTDDataType.INT);
        fields[9] = new XMLFieldInfo(new String[] {"GetCityForecastByZIPResponse" , "GetCityForecastByZIPResult", "ForecastResult", "Forecast+", "Temperatures", "DaytimeHigh"});
        fields[9].setElementDataType(DTDDataType.INT);
        fields[10] = new XMLFieldInfo(new String[] {"GetCityForecastByZIPResponse" , "GetCityForecastByZIPResult", "ForecastResult", "Forecast+", "ProbabilityOfPrecipitation", "Nighttime"});
        fields[10].setElementDataType(DTDDataType.INT);
        fields[11] = new XMLFieldInfo(new String[] {"GetCityForecastByZIPResponse" , "GetCityForecastByZIPResult", "ForecastResult", "Forecast+", "ProbabilityOfPrecipitation", "Daytime"});
        fields[11].setElementDataType(DTDDataType.INT);

       SOAPParam[] parameters = new SOAPParam[1];
       parameters[0] = new SOAPParam("ZIP",java.sql.Types.VARCHAR, "Enter Place Name", "95050", null, true); 		
        
        SOAPQueryFileInfo soapInfo = null;
		try {
			soapInfo = new SOAPQueryFileInfo(wsdlURI, serviceName, portName, operationName, fields, parameters);
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
        
       QbReport report = new QbReport(parent,              // Parent
        							   QbReport.COLUMNAR,   // Type of Report
        							   soapInfo,                        // SOAP Info
        							   mapping,                       // Column Mapping
        							   null,                              // Template Name
        							   null);                             // Properties
        
        try {
            //	 Apply Template with Formula and Script
            report.applyTemplate("WeatherSOAP.pak", true);
        } catch( Exception e ) {
	e.printStackTrace();
        }

        return (new Viewer().getComponent(report));


    }
}